package gregapi.network;

import gregapi.block.IBlockSyncData;
import net.minecraft.block.Block;
import net.minecraft.world.IBlockAccess;

import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteArrayDataOutput;

/**
 * @author Gregorius Techneticies
 * 
 * Transmits the extended Data of a Block.
 */
public class PacketSyncDataInteger extends PacketCoordinates {
	public int mData = 0;
	
	public PacketSyncDataInteger(int aDecoderType) {
		super(aDecoderType);
	}
	
	public PacketSyncDataInteger(int aX, int aY, int aZ, int aData) {
		super(aX, aY, aZ);
		mData = aData;
	}
	
	@Override
	public byte getPacketIDOffset() {
		return -104;
	}
	
	@Override
	public ByteArrayDataOutput encode2(ByteArrayDataOutput aData) {
		aData.writeInt(mData);
		return aData;
	}
	
	@Override
	public PacketCoordinates decode2(int aX, int aY, int aZ, ByteArrayDataInput aData) {
		return new PacketSyncDataInteger(aX, aY, aZ, aData.readInt());
	}
	
	@Override
	public void process(IBlockAccess aWorld, INetworkHandler aNetworkHandler) {
		if (aWorld != null) {
			Block tBlock = aWorld.getBlock(mX, mY, mZ);
			if (tBlock instanceof IBlockSyncData) ((IBlockSyncData)tBlock).receiveDataInteger(aWorld, mX, mY, mZ, mData, aNetworkHandler);
		}
	}
}